<html>
<head>
<title>OGRE: Ogre::NumericAnimationTrack Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1NumericAnimationTrack.html">NumericAnimationTrack</a></div>
<h1>Ogre::NumericAnimationTrack Class Reference</h1><!-- doxytag: class="Ogre::NumericAnimationTrack" --><!-- doxytag: inherits="Ogre::AnimationTrack" -->Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, ie a sequence of keyframes which affect...">AnimationTrack</a> for dealing with generic animable values.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::NumericAnimationTrack:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1NumericAnimationTrack-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#2abae8df7bf7a90ec35cb57a8a412e38">NumericAnimationTrack</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *parent, unsigned short handle)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Constructor.  <a href="#2abae8df7bf7a90ec35cb57a8a412e38"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#85e2b687e0e4952736ee02de3d53bc43">NumericAnimationTrack</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *parent, unsigned short handle, <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> &amp;target)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Constructor, associates with an <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, ie may be keyframed.">AnimableValue</a>.  <a href="#85e2b687e0e4952736ee02de3d53bc43"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#d1c0346a522eed44ee1fcb849e27897e">createNumericKeyFrame</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timePos)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index.  <a href="#d1c0346a522eed44ee1fcb849e27897e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#aa8109fd7c326e9d4c98c0187896e6da">getInterpolatedKeyFrame</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *kf) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> object which contains the interpolated transforms at the time index specified. <p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time (in relation to the whole animation sequence) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>kf</em>&nbsp;</td><td>Keyframe object to store results </td></tr>
  </table>
</dl>
  <a href="#aa8109fd7c326e9d4c98c0187896e6da"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#add219663715ff7f2f74b7255ebcbae4">apply</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> weight=1.0, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> scale=1.0f)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Applies an animation track to the designated target. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time position in the animation to apply. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>weight</em>&nbsp;</td><td>The influence to give to this track, 1.0 for full influence, less to blend with other animations. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>scale</em>&nbsp;</td><td>The scale to apply to translations and scalings, useful for adapting an animation to a different size target. </td></tr>
  </table>
</dl>
  <a href="#add219663715ff7f2f74b7255ebcbae4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#2e9aaebae7953605d698f9c6f4ceb6e5">applyToAnimable</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> &amp;anim, const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> weight=1.0, <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> scale=1.0f)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Applies an animation track to a given animable value.  <a href="#2e9aaebae7953605d698f9c6f4ceb6e5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <br>
<a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#73eb9735e4dbe9370cb8689644d9a33c">getAssociatedAnimable</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a pointer to the associated animable object (if any).  <a href="#73eb9735e4dbe9370cb8689644d9a33c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#89d5b800fa465b59a38ab08ebee07b5a">setAssociatedAnimable</a> (const <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> &amp;val)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets the associated animable object which will be automatically affected by calls to 'apply'.  <a href="#89d5b800fa465b59a38ab08ebee07b5a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#eab662312afde85ea91bae69c35bbad5">getNumericKeyFrame</a> (unsigned short index) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index.  <a href="#eab662312afde85ea91bae69c35bbad5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1NumericAnimationTrack.html">NumericAnimationTrack</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#bbb4ea6a49e00abec1abb65ee4704674">_clone</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *newParent) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clone this track (internal use only).  <a href="#bbb4ea6a49e00abec1abb65ee4704674"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#32de796f12f6afee4c93e12625535577">getHandle</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the handle associated with this track.  <a href="#32de796f12f6afee4c93e12625535577"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#e0c1160b89c7f2be74ae2962239bd732">getNumKeyFrames</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the number of keyframes in this animation.  <a href="#e0c1160b89c7f2be74ae2962239bd732"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#f27f57a984619052cca4726cdfd26f3c">getKeyFrame</a> (unsigned short index) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index.  <a href="#f27f57a984619052cca4726cdfd26f3c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#55533ed5218c6d423e9443afa2580f5a">getKeyFramesAtTime</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **keyFrame1, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **keyFrame2, unsigned short *firstKeyIndex=0) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the 2 <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects which are active at the time given, and the blend value between them.  <a href="#55533ed5218c6d423e9443afa2580f5a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#4517a1b16d6cb601754d98841bb4d7d6">createKeyFrame</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timePos)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index.  <a href="#4517a1b16d6cb601754d98841bb4d7d6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#3e1ccd99179d804992a5224fe811c2dd">removeKeyFrame</a> (unsigned short index)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> by it's index.  <a href="#3e1ccd99179d804992a5224fe811c2dd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#c8f7b83d742998ed46c8cdb10e404df6">removeAllKeyFrames</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Removes all the KeyFrames from this track.  <a href="#c8f7b83d742998ed46c8cdb10e404df6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#715b6d025247c4857a5deba9376ae48c">_keyFrameDataChanged</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.  <a href="#715b6d025247c4857a5deba9376ae48c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#3a07b2082c15608cc24be21e2b6bb822">hasNonZeroKeyFrames</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.  <a href="#3a07b2082c15608cc24be21e2b6bb822"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#d96281be1b189c69a1dbd2283d583503">optimise</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Optimise the current track by removing any duplicate keyframes.  <a href="#d96281be1b189c69a1dbd2283d583503"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#7aab09df8cf0fea5b1a53df263b9e2c1">_collectKeyFrameTimes</a> (std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;keyFrameTimes)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method to collect keyframe times, in unique, ordered format.  <a href="#7aab09df8cf0fea5b1a53df263b9e2c1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#6f341ad134c0254f15a0cba2bbae4097">_buildKeyFrameIndexMap</a> (const std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;keyFrameTimes)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.  <a href="#6f341ad134c0254f15a0cba2bbae4097"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">KeyFrameList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">KeyFrameIndexMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map used to translate global keyframe time lower bound index to local lower bound index.  <a href="#27b9b55f9a560e3b7c83f0d47676fc51"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#68c6edea0b9363bb381669d246879141">createKeyFrameImpl</a> (<a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> time)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a keyframe implementation - must be overridden.   <a href="#68c6edea0b9363bb381669d246879141"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#4e61fb2e00abd26a854d122452cb21a0">populateClone</a> (<a class="el" href="classOgre_1_1AnimationTrack.html">AnimationTrack</a> *clone) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal method for clone implementation.  <a href="#4e61fb2e00abd26a854d122452cb21a0"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#9abd089b3278141471254455f45c648d">mTargetAnim</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Target to animate.  <a href="#9abd089b3278141471254455f45c648d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">KeyFrameList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#8a9bee08f6fa537fc0bcfcee2423775c">mKeyFrames</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#ea479089005d263e195cde7e4faca665">mParent</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#5fb5dc3c01452aa4d542981485d15080">mHandle</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">KeyFrameIndexMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#2c053bac1d2eedc782eb24b79dc79a21">mKeyFrameIndexMap</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, ie a sequence of keyframes which affect...">AnimationTrack</a> for dealing with generic animable values. 
<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00237">237</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="501aac9ae307fd6813a31792404cf770"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::KeyFrameList" ref="501aac9ae307fd6813a31792404cf770" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>*&gt; <a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">Ogre::AnimationTrack::KeyFrameList</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00216">216</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="27b9b55f9a560e3b7c83f0d47676fc51"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::KeyFrameIndexMap" ref="27b9b55f9a560e3b7c83f0d47676fc51" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&gt; <a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">Ogre::AnimationTrack::KeyFrameIndexMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map used to translate global keyframe time lower bound index to local lower bound index. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00222">222</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="2abae8df7bf7a90ec35cb57a8a412e38"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::NumericAnimationTrack" ref="2abae8df7bf7a90ec35cb57a8a412e38" args="(Animation *parent, unsigned short handle)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::NumericAnimationTrack::NumericAnimationTrack           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td>
          <td class="paramname"> <em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>handle</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor. 
<p>

</div>
</div><p>
<a class="anchor" name="85e2b687e0e4952736ee02de3d53bc43"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::NumericAnimationTrack" ref="85e2b687e0e4952736ee02de3d53bc43" args="(Animation *parent, unsigned short handle, AnimableValuePtr &amp;target)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::NumericAnimationTrack::NumericAnimationTrack           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td>
          <td class="paramname"> <em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>target</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Constructor, associates with an <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, ie may be keyframed.">AnimableValue</a>. 
<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="d1c0346a522eed44ee1fcb849e27897e"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::createNumericKeyFrame" ref="d1c0346a522eed44ee1fcb849e27897e" args="(Real timePos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a>* Ogre::NumericAnimationTrack::createNumericKeyFrame           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>timePos</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0); </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timePos</em>&nbsp;</td><td>The time from which this <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> will apply. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="aa8109fd7c326e9d4c98c0187896e6da"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getInterpolatedKeyFrame" ref="aa8109fd7c326e9d4c98c0187896e6da" args="(const TimeIndex &amp;timeIndex, KeyFrame *kf) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::NumericAnimationTrack::getInterpolatedKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>kf</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> object which contains the interpolated transforms at the time index specified. <p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time (in relation to the whole animation sequence) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>kf</em>&nbsp;</td><td>Keyframe object to store results </td></tr>
  </table>
</dl>
 
<p>

<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#48a8e96d4cb65f050dfed427f4442aa4">Ogre::AnimationTrack</a>.</p>

</div>
</div><p>
<a class="anchor" name="add219663715ff7f2f74b7255ebcbae4"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::apply" ref="add219663715ff7f2f74b7255ebcbae4" args="(const TimeIndex &amp;timeIndex, Real weight=1.0, Real scale=1.0f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::NumericAnimationTrack::apply           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>weight</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>scale</em> = <code>1.0f</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Applies an animation track to the designated target. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time position in the animation to apply. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>weight</em>&nbsp;</td><td>The influence to give to this track, 1.0 for full influence, less to blend with other animations. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>scale</em>&nbsp;</td><td>The scale to apply to translations and scalings, useful for adapting an animation to a different size target. </td></tr>
  </table>
</dl>
 
<p>

<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#a32b2807aee58478f96e75bfa44141cc">Ogre::AnimationTrack</a>.</p>

</div>
</div><p>
<a class="anchor" name="2e9aaebae7953605d698f9c6f4ceb6e5"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::applyToAnimable" ref="2e9aaebae7953605d698f9c6f4ceb6e5" args="(const AnimableValuePtr &amp;anim, const TimeIndex &amp;timeIndex, Real weight=1.0, Real scale=1.0f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::NumericAnimationTrack::applyToAnimable           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>anim</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>weight</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>scale</em> = <code>1.0f</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Applies an animation track to a given animable value. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>anim</em>&nbsp;</td><td>The <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, ie may be keyframed.">AnimableValue</a> to which to apply the animation </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time position in the animation to apply. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>weight</em>&nbsp;</td><td>The influence to give to this track, 1.0 for full influence, less to blend with other animations. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>scale</em>&nbsp;</td><td>The scale to apply to translations and scalings, useful for adapting an animation to a different size target. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="73eb9735e4dbe9370cb8689644d9a33c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getAssociatedAnimable" ref="73eb9735e4dbe9370cb8689644d9a33c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a>&amp; Ogre::NumericAnimationTrack::getAssociatedAnimable           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a pointer to the associated animable object (if any). 
<p>

</div>
</div><p>
<a class="anchor" name="89d5b800fa465b59a38ab08ebee07b5a"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::setAssociatedAnimable" ref="89d5b800fa465b59a38ab08ebee07b5a" args="(const AnimableValuePtr &amp;val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::NumericAnimationTrack::setAssociatedAnimable           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>val</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets the associated animable object which will be automatically affected by calls to 'apply'. 
<p>

</div>
</div><p>
<a class="anchor" name="eab662312afde85ea91bae69c35bbad5"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getNumericKeyFrame" ref="eab662312afde85ea91bae69c35bbad5" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a>* Ogre::NumericAnimationTrack::getNumericKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index. 
<p>

</div>
</div><p>
<a class="anchor" name="bbb4ea6a49e00abec1abb65ee4704674"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_clone" ref="bbb4ea6a49e00abec1abb65ee4704674" args="(Animation *newParent) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1NumericAnimationTrack.html">NumericAnimationTrack</a>* Ogre::NumericAnimationTrack::_clone           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&nbsp;</td>
          <td class="paramname"> <em>newParent</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clone this track (internal use only). 
<p>

</div>
</div><p>
<a class="anchor" name="68c6edea0b9363bb381669d246879141"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::createKeyFrameImpl" ref="68c6edea0b9363bb381669d246879141" args="(Real time)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* Ogre::NumericAnimationTrack::createKeyFrameImpl           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>time</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a keyframe implementation - must be overridden.  
<p>

<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#a344f22d2582a0adacea56bf7b6dcd7d">Ogre::AnimationTrack</a>.</p>

</div>
</div><p>
<a class="anchor" name="32de796f12f6afee4c93e12625535577"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getHandle" ref="32de796f12f6afee4c93e12625535577" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short Ogre::AnimationTrack::getHandle           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the handle associated with this track. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00125">125</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e0c1160b89c7f2be74ae2962239bd732"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getNumKeyFrames" ref="e0c1160b89c7f2be74ae2962239bd732" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned short Ogre::AnimationTrack::getNumKeyFrames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the number of keyframes in this animation. 
<p>

</div>
</div><p>
<a class="anchor" name="f27f57a984619052cca4726cdfd26f3c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getKeyFrame" ref="f27f57a984619052cca4726cdfd26f3c" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* Ogre::AnimationTrack::getKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index. 
<p>

</div>
</div><p>
<a class="anchor" name="55533ed5218c6d423e9443afa2580f5a"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getKeyFramesAtTime" ref="55533ed5218c6d423e9443afa2580f5a" args="(const TimeIndex &amp;timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::AnimationTrack::getKeyFramesAtTime           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **&nbsp;</td>
          <td class="paramname"> <em>keyFrame1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **&nbsp;</td>
          <td class="paramname"> <em>keyFrame2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short *&nbsp;</td>
          <td class="paramname"> <em>firstKeyIndex</em> = <code>0</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the 2 <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects which are active at the time given, and the blend value between them. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timeIndex</em>&nbsp;</td><td>The time index. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>keyFrame1</em>&nbsp;</td><td>Pointer to a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> pointer which will receive the pointer to the keyframe just before or at this time index. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>keyFrame2</em>&nbsp;</td><td>Pointer to a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> pointer which will receive the pointer to the keyframe just after this time index. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>firstKeyIndex</em>&nbsp;</td><td>Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe incase the caller needs it. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>Parametric value indicating how far along the gap between the 2 keyframes the timeIndex value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 &lt;= returnValue &lt; 1.0 . </dd></dl>

</div>
</div><p>
<a class="anchor" name="4517a1b16d6cb601754d98841bb4d7d6"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::createKeyFrame" ref="4517a1b16d6cb601754d98841bb4d7d6" args="(Real timePos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* Ogre::AnimationTrack::createKeyFrame           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td>
          <td class="paramname"> <em>timePos</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0); </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>this method will always create a keyframe even if the track already has a keyframe at the given time position. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>timePos</em>&nbsp;</td><td>The time from which this <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> will apply. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="3e1ccd99179d804992a5224fe811c2dd"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::removeKeyFrame" ref="3e1ccd99179d804992a5224fe811c2dd" args="(unsigned short index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::removeKeyFrame           </td>
          <td>(</td>
          <td class="paramtype">unsigned short&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Removes a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> by it's index. 
<p>

</div>
</div><p>
<a class="anchor" name="c8f7b83d742998ed46c8cdb10e404df6"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::removeAllKeyFrames" ref="c8f7b83d742998ed46c8cdb10e404df6" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::removeAllKeyFrames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Removes all the KeyFrames from this track. 
<p>

</div>
</div><p>
<a class="anchor" name="715b6d025247c4857a5deba9376ae48c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_keyFrameDataChanged" ref="715b6d025247c4857a5deba9376ae48c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::_keyFrameDataChanged           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data. 
<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1NodeAnimationTrack.html#c63ec3b7f27897f2223aca60f4c90422">Ogre::NodeAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00197">197</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="3a07b2082c15608cc24be21e2b6bb822"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::hasNonZeroKeyFrames" ref="3a07b2082c15608cc24be21e2b6bb822" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::AnimationTrack::hasNonZeroKeyFrames           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out. 
<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1NodeAnimationTrack.html#33dfa5ceaf4d6636da3a46038068aa11">Ogre::NodeAnimationTrack</a>, and <a class="el" href="classOgre_1_1VertexAnimationTrack.html#fa0e80d8dd451a65d89f7f9365a929e5">Ogre::VertexAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00203">203</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="d96281be1b189c69a1dbd2283d583503"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::optimise" ref="d96281be1b189c69a1dbd2283d583503" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::optimise           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Optimise the current track by removing any duplicate keyframes. 
<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1NodeAnimationTrack.html#bab18a48c2cf56ef09d5049fa8289ad2">Ogre::NodeAnimationTrack</a>, and <a class="el" href="classOgre_1_1VertexAnimationTrack.html#366c0dfa30d9b59d685ff1f7622b5ba7">Ogre::VertexAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00206">206</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7aab09df8cf0fea5b1a53df263b9e2c1"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_collectKeyFrameTimes" ref="7aab09df8cf0fea5b1a53df263b9e2c1" args="(std::vector&lt; Real &gt; &amp;keyFrameTimes)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::_collectKeyFrameTimes           </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>keyFrameTimes</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method to collect keyframe times, in unique, ordered format. 
<p>

</div>
</div><p>
<a class="anchor" name="6f341ad134c0254f15a0cba2bbae4097"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_buildKeyFrameIndexMap" ref="6f341ad134c0254f15a0cba2bbae4097" args="(const std::vector&lt; Real &gt; &amp;keyFrameTimes)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::_buildKeyFrameIndexMap           </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; <a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt; &amp;&nbsp;</td>
          <td class="paramname"> <em>keyFrameTimes</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method to build keyframe time index map to translate global lower bound index to local lower bound index. 
<p>

</div>
</div><p>
<a class="anchor" name="4e61fb2e00abd26a854d122452cb21a0"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::populateClone" ref="4e61fb2e00abd26a854d122452cb21a0" args="(AnimationTrack *clone) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::AnimationTrack::populateClone           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1AnimationTrack.html">AnimationTrack</a> *&nbsp;</td>
          <td class="paramname"> <em>clone</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal method for clone implementation. 
<p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="9abd089b3278141471254455f45c648d"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mTargetAnim" ref="9abd089b3278141471254455f45c648d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> <a class="el" href="classOgre_1_1NumericAnimationTrack.html#9abd089b3278141471254455f45c648d">Ogre::NumericAnimationTrack::mTargetAnim</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Target to animate. 
<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00288">288</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8a9bee08f6fa537fc0bcfcee2423775c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mKeyFrames" ref="8a9bee08f6fa537fc0bcfcee2423775c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimationTrack.html#501aac9ae307fd6813a31792404cf770">KeyFrameList</a> <a class="el" href="classOgre_1_1AnimationTrack.html#8a9bee08f6fa537fc0bcfcee2423775c">Ogre::AnimationTrack::mKeyFrames</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00217">217</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="ea479089005d263e195cde7e4faca665"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mParent" ref="ea479089005d263e195cde7e4faca665" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Animation.html">Animation</a>* <a class="el" href="classOgre_1_1AnimationTrack.html#ea479089005d263e195cde7e4faca665">Ogre::AnimationTrack::mParent</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00218">218</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="5fb5dc3c01452aa4d542981485d15080"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mHandle" ref="5fb5dc3c01452aa4d542981485d15080" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short <a class="el" href="classOgre_1_1AnimationTrack.html#5fb5dc3c01452aa4d542981485d15080">Ogre::AnimationTrack::mHandle</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00219">219</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2c053bac1d2eedc782eb24b79dc79a21"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mKeyFrameIndexMap" ref="2c053bac1d2eedc782eb24b79dc79a21" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimationTrack.html#27b9b55f9a560e3b7c83f0d47676fc51">KeyFrameIndexMap</a> <a class="el" href="classOgre_1_1AnimationTrack.html#2c053bac1d2eedc782eb24b79dc79a21">Ogre::AnimationTrack::mKeyFrameIndexMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h-source.html#l00223">223</a> of file <a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreAnimationTrack_8h-source.html">OgreAnimationTrack.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:07 2008
</p>
</body>
</html>
